View Issue Details

IDProjectCategoryView StatusLast Update
0028071LazarusWidgetsetpublic2017-04-30 17:29
ReporterWallaby Assigned ToJuha Manninen  
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
Product Version1.4 
Summary0028071: Memo top border is clipped
DescriptionOn OS X 10.10.3 in the Carbon widgetset a TMemo dropped on a form has the top edge clipped and not painted properly. The same issue can be seen in Lazarus itself. Please refer to the attached files.
TagsNo tags attached.
Fixed in Revisionr54782
LazTarget-
WidgetsetCarbon
Attached Files

Activities

Wallaby

2015-05-11 07:08

reporter  

Squall64

2015-08-13 21:13

reporter  

memo.png (5,814 bytes)   
memo.png (5,814 bytes)   

Squall64

2015-08-13 21:13

reporter  

patch.diff (587 bytes)   
Index: lcl/interfaces/carbon/carbonedits.pp
===================================================================
--- lcl/interfaces/carbon/carbonedits.pp	(revision 49664)
+++ lcl/interfaces/carbon/carbonedits.pp	(working copy)
@@ -1768,9 +1768,9 @@
     if not Assigned(ctx) then Exit;
     HIViewGetBounds(TCarbonMemo(AWidget).FBorder, cg{%H-});
     cg.origin.x:=0.5;
-    cg.origin.y:=0.5;
+    cg.origin.y:=1;
     cg.size.width:=cg.size.width-2;
-    cg.size.height:=cg.size.height-1;
+    cg.size.height:=cg.size.height-2;
 
     if TCarbonMemo(AWidget).FDrawBorder then
     begin
patch.diff (587 bytes)   

CudaText man

2017-04-30 15:05

reporter   ~0100008

Last edited: 2017-04-30 15:05

View 2 revisions

@Juha,
diff,
this is needed too
(will test it soon, seems Ok)

Juha Manninen

2017-04-30 15:52

developer   ~0100012

> will test it soon, seems Ok

Please test and confirm first. I must apply MacOS patches without testing.

CudaText man

2017-04-30 16:43

reporter  

memo2.diff (937 bytes)   
Index: lcl/interfaces/carbon/carbonedits.pp
===================================================================
--- lcl/interfaces/carbon/carbonedits.pp	(revision 54780)
+++ lcl/interfaces/carbon/carbonedits.pp	(working copy)
@@ -1773,9 +1773,9 @@
     if not Assigned(ctx) then Exit;
     HIViewGetBounds(TCarbonMemo(AWidget).FBorder, cg{%H-});
     cg.origin.x:=0.5;
-    cg.origin.y:=0.5;
+    cg.origin.y:=1;
     cg.size.width:=cg.size.width-2;
-    cg.size.height:=cg.size.height-1;
+    cg.size.height:=cg.size.height-2;
 
     if TCarbonMemo(AWidget).FDrawBorder then
     begin
@@ -1787,7 +1787,7 @@
         clips[1].origin.x:=0;
         clips[1].origin.y:=cg.size.height-ScrollSz;
         clips[1].size.width:=cg.size.width-ScrollSz+2;
-        clips[1].size.height:=ScrollSz+1;
+        clips[1].size.height:=ScrollSz+2;
         CGContextClipToRects(ctx, @clips, 2);
       end;
       FillChar(frm{%H-}, sizeof(frm), 0);
memo2.diff (937 bytes)   

CudaText man

2017-04-30 16:43

reporter   ~0100016

Last edited: 2017-04-30 16:44

View 2 revisions

Memo2.diff:
same++ added pixel fix for bottom border of memo.
Tested on CudaText

Juha Manninen

2017-04-30 17:29

developer   ~0100018

Applied, thanks.

Issue History

Date Modified Username Field Change
2015-05-11 07:08 Wallaby New Issue
2015-05-11 07:08 Wallaby File Added: Screen Shot 2015-05-11 at 3.03.03 pm.png
2015-08-13 21:13 Squall64 File Added: memo.png
2015-08-13 21:13 Squall64 File Added: patch.diff
2017-04-30 15:05 CudaText man Note Added: 0100008
2017-04-30 15:05 CudaText man Note Edited: 0100008 View Revisions
2017-04-30 15:52 Juha Manninen Note Added: 0100012
2017-04-30 16:43 CudaText man File Added: memo2.diff
2017-04-30 16:43 CudaText man Note Added: 0100016
2017-04-30 16:44 CudaText man Note Edited: 0100016 View Revisions
2017-04-30 17:24 Juha Manninen Assigned To => Juha Manninen
2017-04-30 17:24 Juha Manninen Status new => assigned
2017-04-30 17:29 Juha Manninen Fixed in Revision => r54782
2017-04-30 17:29 Juha Manninen LazTarget => -
2017-04-30 17:29 Juha Manninen Note Added: 0100018
2017-04-30 17:29 Juha Manninen Status assigned => resolved
2017-04-30 17:29 Juha Manninen Resolution open => fixed